<html>

  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <script src="js/nanocurrency-web-js/index.min.js" type="text/javascript"></script>
    <script src="js/nostr-tools/nostr.bundle.js" type="text/javascript"></script>
    <script type="text/javascript">
    var nanoNode = 'http://localhost:7076';
    var relay = NostrTools.relayInit('wss://nos.lol');

    // Nostr
    var nostrPvKey = NostrTools.generatePrivateKey();
    var nostrPbKey = NostrTools.getPublicKey(nostrPvKey);

    var nsec = NostrTools.nip19.nsecEncode(nostrPvKey);
    var npub = NostrTools.nip19.npubEncode(nostrPbKey);

    var nostrPublicChannel;

    async function connect() {
      relay = NostrTools.relayInit('wss://nos.lol');

      relay.on('connect', () => {
        console.log(`connected to ${relay.url}`)
      })
      relay.on('error', () => {
        console.log(`failed to connect to ${relay.url}`)
      })

      await relay.connect();
    }

    function disconnect() {
      relay.close()
    }

    async function listMessages(chatId) {
      await connect();

      if (chatId.startsWith("nevent"))
      chatId = NostrTools.nip19.decode(chatId).data.id;

      let events = await relay.list([
        {
          kinds: [42],
          '#e': [chatId],
        }
      ]).then(event => console.log(event));

      disconnect();
      return event;
    }

    async function findRelays() {
      await connect();

      let relays = await relay.list([
        {
          kinds: [10002],  
          tags: [
            [ "r", "wss://nos.lol" ]
          ],
          content: "",
        }
      ]).then(event => console.log(event));

      disconnect();
      return relays;
    }

    async function createPublicChatChannel(name, about, picture, pvtKey) {
      await connect();

      var channelMetadata = {
        name: name,
        about: about,
        picture: picture,
      }

      const template = {
        content: channelMetadata,
        created_at: Math.floor(Date.now() / 1000),
      }

      var event = NostrTools.nip28.channelCreateEvent(template, nostrPvKey);
      var signed = NostrTools.finishEvent(event, nostrPvKey);

      await relay.publish(signed);

      disconnect();
      return event;
    }

    async function sendNostrMessage(message, chatCreationEvent, pvtKey) {
      await connect();
      const template = {
        channel_create_event_id: chatCreationEvent.id,
        relay_url: 'wss://nos.lol',
        content: message,
        created_at: Math.floor(Date.now() / 1000),
      }

      var event = NostrTools.nip28.channelMessageEvent(template, pvtKey)
      await relay.publish(event);

      disconnect();
      return event;
    }

    async function createChannelAndSendMessage() {
      await createPublicChatChannel(
        document.getElementById("txtChannelName").value,
        document.getElementById("txtChannelDesc").value,
        document.getElementById("txtChannelPic").value,
        nostrPvKey
      ).then(event => {
        document.getElementById("nostrChat").innerHTML = "<b>Chat nevent: </b>" + NostrTools.nip19.neventEncode(event);
        document.getElementById("nostrChatId").innerHTML = "<b>Chat Id: </b>" + event.id;
        nostrPublicChannel = event;
      })
    }

    // Nano
    var verifiedPeers = [];

    async function sendNanoRPC(data, node) {
      const controller = new AbortController();
      const timeoutId = setTimeout(() => controller.abort(), 3000);

      var data = await fetch(node, {
        signal: controller.signal,
        method: 'POST',
        headers: {
          'Content-Type': 'application/json',
        },
        body: JSON.stringify(data),
      }).then(response => response.json())
        .then(data => data)
        .catch((error) => {
        });
      return data;
    }

    async function createWallet() {
      data = {
        "action": "wallet_create"
      }

      return await sendNanoRPC(data, nanoNode);
    }

    async function getAccountInfo(account) {
      data = {
        "action": "account_info",
        "account": account
      }

      return await sendNanoRPC(data, nanoNode);
    }

    async function getRepresentative(address) {
      data = {
        "action": "account_representative",
        "address": address
      }

      return await sendNanoRPC(data, nanoNode);
    }

    async function addAccountToWallet(pvtKey, wallet) {
      data = {
        "action": "wallet_add",
        "wallet": wallet,
        "key": pvtKey
      }

      return await sendNanoRPC(data, nanoNode);
    }

    async function getKeypair(data) {

      data = await sendNanoRPC(data, nanoNode);

      document.getElementById("keys").style.visibility = "visible";
      document.getElementById("txtSignKey").value = data.private;

      document.getElementById("pvtKey").innerHTML = "<b>Private: </b>" + data.private;
      document.getElementById("pbKey").innerHTML = "<b>Public: </b>" + data.public;
      document.getElementById("address").innerHTML = "<b>Address: </b>" + data.account;
    }

    async function printBlockCount(data) {

      data = await sendNanoRPC(data, nanoNode);

      document.getElementById("blockCount").style.visibility = "visible";

      document.getElementById("count").innerHTML = "<b>Count: </b>" + data.count;
      document.getElementById("unchecked").innerHTML = "<b>Unchecked: </b>" + data.unchecked;
      document.getElementById("cemented").innerHTML = "<b>Cemented: </b>" + data.cemented;
    }

    async function receive(pvtKey, account) {
      wallet = (await createWallet()).wallet;
      accWallet = await addAccountToWallet(pvtKey, wallet);
      receivables = await getReceivables("receivable", account);

      for (const block in receivables.blocks) {
        data = {
          "action": "receive",
          "wallet": wallet,
          "account": account,
          "block": block
        }
        sendNanoRPC(data, nanoNode);
      }
    }

    async function send(pvtKey, srcAccount, destAccount, amount, msgSignature) {
      wallet = (await createWallet()).wallet;
      accWallet = await addAccountToWallet(pvtKey, wallet);

      data = {
        "action": "send",
        "wallet": wallet,
        "source": srcAccount,
        "destination": destAccount,
        "amount": NanocurrencyWeb.tools.convert(amount, 'NANO', 'RAW'),
        "id": msgSignature
      }

      sendNanoRPC(data, nanoNode);
    }

    async function getReceivables(action, account) {
      data = {
        "action": action,
        "account": account,
        "source": "true"
      }

      return sendNanoRPC(data, nanoNode);
    }

    async function printReceivables(action, account) {

      data = await getReceivables(action, account);
      document.getElementById("receivables").innerHTML = "<b>Recebíveis: </b>" + JSON.stringify(data);

      tblReceivables = document.getElementById("tblReceivables");

      for (const account in data.blocks) {
        let amount = data.blocks[account].amount;
        let source = data.blocks[account].source;

        let row = tblReceivables.insertRow();

        let cellSource = row.insertCell();
        cellSource.appendChild(document.createTextNode(source));

        let cellAmount = row.insertCell();
        cellAmount.appendChild(document.createTextNode(parseFloat(NanocurrencyWeb.tools.convert(amount, 'RAW', 'NANO'))));
      }
    }

    function sign(pvtKey, msg) {
      var signature = NanocurrencyWeb.tools.sign(pvtKey, msg);
      document.getElementById("signature").innerHTML = "<b>Assinatura: </b>" + signature;
      document.getElementById("signatureMsg").innerHTML = "<b>Assinatura + Mensagem: </b>" + signature + "." + document.getElementById("txtSignMsg").value;
      document.getElementById("txtVerifySig").value = signature;
    }

    function verify(pbKey, signature, msg) {
      if (pbKey.startsWith("nano"))
      pbKey = NanocurrencyWeb.tools.addressToPublicKey(pbKey);

      var verify = NanocurrencyWeb.tools.verify(pbKey, signature, msg);
      document.getElementById("verify").innerHTML = "<b>Autenticado: </b>" + (verify ? "sim" : "não");
    }

    async function getPeers() {
      data = {
        "action": "peers"//,
        // "raw": "true"
      }
      console.log('getPeers', nanoNode);

      return await sendNanoRPC(data, nanoNode);
    }

    async function getBlockCount(node) {
      data = {
        "action": "block_count"
      }

      return await sendNanoRPC(data, node);
    }

    function loadSavedNodes() {
      var selectElement = document.getElementById('nano-node');
      var savedNodes = JSON.parse(localStorage.getItem('nano_nodes'));

      // console.log(savedNodes);

      if (savedNodes != null) {
        for (node of savedNodes) {
          var opt = document.createElement('option');
          opt.value = node;
          opt.innerHTML = node;
          selectElement.appendChild(opt);
          if (!verifiedPeers.includes(node)) {
            verifiedPeers.push(node);
          }
        }
      }
    }

    async function findNodes() {
      var selectElement = document.getElementById('nano-node');
      var peers = (await getPeers()).peers;
      console.log(peers);

      // for (opt of selectElement.options) {
      //   verifiedPeers.push(opt.value);
      // }

      // console.log(verifiedPeers);

      var i, L = selectElement.options.length - 1;
      for(i = L; i >= 0; i--) {
        selectElement.remove(i);
      }

      loadSavedNodes();

      for (peer in peers) {
        // console.log(peer);
        var ip = peer.split(':')[3].replace(']','');
        var port = parseInt(peer.split(':')[4]) + 1;
        var rpc = "http://" + ip + ":" + port;  /* + ":" + (parseInt(peer.port) + 1 );*/
        // console.log(rpc);

        // if (peer.port != 7075)
        // console.log(rpc);

        var blockCount = await getBlockCount(rpc);

        if (blockCount !== undefined) {
          console.log('peer', rpc);
          if (!verifiedPeers.includes(rpc)) {
            verifiedPeers.push(rpc);
          }
        }
      }

      localStorage.setItem('nano_nodes', JSON.stringify(verifiedPeers));

      for (peer of verifiedPeers) {
        var opt = document.createElement('option');
        opt.value = peer;
        opt.innerHTML = peer;
        selectElement.appendChild(opt);
      }
    }

    </script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/purecss@3.0.0/build/pure-min.css"
      integrity="sha384-X38yfunGUhNzHpBaEBsWLO+A0HDYOQi8ufWDkZ0k9e0eXz/tH3II7uKZ9msv++Ls" crossorigin="anonymous">
  </head>

  <body onload="loadSavedNodes(); findRelays()">

    <h1>Nano</h1>

    <select id="nano-node" onchange="nanoNode = this.value; console.log(nanoNode)">
      <option value="http://localhost:7076" selected>http://localhost:7076</option>
      <option value="https://rainstorm.city/api">https://rainstorm.city/api</option>
      <option value="https://nault.nanos.cc/proxy">https://nault.nanos.cc/proxy</option>
      <!-- <option value="http://167.71.253.95:7076">167.71.253.95</option> -->
      <!-- <option value="http://18.140.171.164:7076">18.140.171.164</option> -->
      <!-- <option value="http://188.40.212.66:7076">188.40.212.66</option> -->
      <!-- <option value="http://139.180.168.194:7076">139.180.168.194</option> -->
      <!-- <option value="http://65.108.95.8:7076">65.108.95.8</option> -->
      <!-- <option value="http://140.116.245.162:7076">140.116.245.162</option> -->
      <!-- <option value="http://164.92.85.23:7076">164.92.85.23</option> -->
      <!-- <option value="http://164.90.147.13:7076">164.90.147.13</option> -->
      <!-- <option value="http://94.130.135.50:7076">94.130.135.50</option> -->
      <!-- <option value="http://52.53.43.163:7076">52.53.43.163</option> -->
      <!-- <option value="http://121.140.205.84:7076">121.140.205.84</option> -->
      <!-- <option value="http://98.35.209.116:7076">98.35.209.116</option> -->
    </select>

    <br />

    <input type="button" value="Block Count" onClick='printBlockCount({ "action": "block_count" })' />
    <input type="button" value="Find Nodes" onClick='findNodes()' />
    <input type="button" value="Create Keys" onClick='getKeypair({ "action": "key_create" })' /><br />

    <div id="keys" style="visibility: hidden;">
      <hr />
      <p id="pvtKey"></p>
      <p id="pbKey"></p>
      <p id="address"></p>
    </div>

    <div id="blockCount" style="visibility: hidden;">
      <hr />
      <p id="count"></p>
      <p id="unchecked"></p>
      <p id="cemented"></p>
    </div>

    <hr />

    <h2>Assinar Mensagem</h2>

    <label for="txtSignKey">Chave Privada: </label>
    <input type="text" id="txtSignKey" />

    <br />

    <label for="txtSignMsg">Mensagem: </label>
    <input type="text" id="txtSignMsg" />

    <br />

    <input type="button" value="Sign"
      onClick='sign(document.getElementById("txtSignKey").value, document.getElementById("txtSignMsg").value)' />

    <p id="signature"></p>
    <p id="signatureMsg"></p>

    <hr />

    <h2>Verificar Mensagem</h2>

    <label for="txtSignMsg">Mensagem: </label>
    <input type="text" id="txtVerifyMsg" />

    <br />

    <label for="txtVerifySig">Assinatura: </label>
    <input type="text" id="txtVerifySig" />

    <br />

    <label for="txtVerifyKey">Endereço: </label>
    <input type="text" id="txtVerifyKey" />
    <br />

    <input type="button" value="Verify"
      onClick='verify(document.getElementById("txtVerifyKey").value, document.getElementById("txtVerifySig").value, document.getElementById("txtVerifyMsg").value)' />
    <p id="verify"></p>

    <hr />

    <h2>Recebíveis</h2>

    <label for="txtHistoryAddress">Endereço: </label>
    <input type="text" id="txtHistoryAddress" />

    <select id="action">
      <option value="pending">Pending</option>
      <option value="receivable">Receivable</option>
    </select>

    <input type="button" value="Ver Recebíveis" onClick='printReceivables(
      document.getElementById("action").value,
      document.getElementById("txtHistoryAddress").value
      )' />

    <br />

    <p id="receivables"></p>
    <table id="tblReceivables">
      <tr>
        <th>Origem</th>
        <th>Quantia</th>
      </tr>
    </table>

    <hr />

    <h2>Receber:</h2>

    <input type="button" value="Receber tudo" onclick='receive(
      document.getElementById("pvtKey").innerText.split(":")[1].trim(),
      document.getElementById("address").innerText.split(":")[1].trim()
      )' />

    <hr />

    <h2>Enviar:</h2>

    <label for="txtEnderecoDestino">Endereço: </label>
    <input type="text" id="txtEnderecoDestino" />

    <br />

    <label for="txtQuantidade">Quantidade: </label>
    <input type="number" id="txtQuantidade" />

    <input type="button" value="Enviar" onclick='send(
      document.getElementById("pvtKey").innerText.split(":")[1].trim(),
      document.getElementById("address").innerText.split(":")[1].trim(),
      document.getElementById("txtEnderecoDestino").value,
      document.getElementById("txtQuantidade").value,
      document.getElementById("nostrChatMsg").innerText.split(":")[1].trim()
      )' />

    <br />

    <hr />

    <h1>Nostr</h1>

    <label for="txtChannelName">Nome do Canal: </label>
    <input type="text" id="txtChannelName" />

    <br />

    <label for="txtChannelDesc">Descrição do Canal: </label>
    <input type="text" id="txtChannelDesc" />

    <br />

    <label for="txtChannelPic">Imagem do Canal: </label>
    <input type="text" id="txtChannelPic" />

    <br />

    <input type="button" value="Create Nostr Public Channel" onClick='createChannelAndSendMessage()' />

    <p id="nostrChatId"></p>
    <p id="nostrChat"></p>

    <hr />

    <h2>Enviar Mensagem</h2>

    <br />

    <label for="txtNostrMsg">Mensagem: </label>

    <br />

    <textarea id="txtNostrMsg"></textarea>

    <br />

    <input type="button" id="btnSendMessage" onclick="sendNostrMessage(
      document.getElementById('txtNostrMsg').value,
      nostrPublicChannel,
      nostrPvKey
      ).then(ev => {
      document.getElementById('nostrChatMsg').innerHTML = '<b>Chat Message: </b>' + NostrTools.nip19.neventEncode(ev);
      })" value="Enviar" />

    <br />

    <p id="nostrChatMsg"></p>

    <hr />

    <input type="text" id="txtEventId" />
    <input type="button" value="Subscribe to Nostr Public Channel"
      onClick='listMessages(document.getElementById("txtEventId").value)' /><br />

  </body>

</html>
